########################## TCL Event Handlers ##########################
#
#  Created by chudoyakoveb68  Tue May 11 00:10:48 2006  ()
#
########################################################################


  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

#=============================================================
#The following command invokes the warning mode and the default settings.
#        .
#=============================================================

source "[MOM_ask_env_var UGII_CAM_POST_DIR]ugpost_base.tcl"

#source "[MOM_ask_env_var UGII_CAM_POST_DIR]/Vstar/vstar.tcl"

#=============================================================
#      .
#=============================================================
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl ;
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ;
  MOM_set_debug_mode OFF

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_4th_axis_ang_offset               "0.0"
  set mom_kin_4th_axis_center_offset(0)         "-33.0"  ;#         
  set mom_kin_4th_axis_center_offset(1)         "0.0"
  set mom_kin_4th_axis_center_offset(2)         "-480.0"  ;# (-300)+(-180)-      
#                                                                     
  #set mom_kin_4th_axis_center_offset(2)         "-300.0"
  #set mom_kin_4th_axis_zero                     "-90.0"
  #set mom_kin_4th_axis_zero                     "180.0"
  set mom_kin_4th_axis_zero                     "-270.0"
  set mom_kin_5th_axis_ang_offset               "0.0"
  set mom_kin_5th_axis_center_offset(0)         "0.0"
  set mom_kin_5th_axis_center_offset(1)         "0.0"
  set mom_kin_5th_axis_center_offset(2)         "0.0"
# set mom_kin_pivot_gauge_offset                "80.0"
  set mom_kin_pivot_dist_vec(0)                 "480.0"
# set mom_kin_pivot_dist_vec(0)                 "-300.0"
  set mom_kin_pivot_dist_vec(2)                 "33.0"
  set mom_kin_pivot_guage_offset                ""
  set mom_kin_tool_change_time                   "3.0"




#=============================================================
proc PB_CMD_Call_master_process { } {
#=============================================================
 global mom_kin_4th_axis_center_offset
 global mom_kin_pivot_dist_vec
 global mom_warning_info
 global mom_event_handler_file_name

 global angle_head_L_param
 global angle_head_P_param
 if {[info exists angle_head_L_param] == 0} { set angle_head_L_param 0.0 }
 if {[info exists angle_head_P_param] == 0} { set angle_head_P_param 0.0 }

 global cam_post_dir
 if {[info exists cam_post_dir]==0} { set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR] ; }

 set path ""
 set str [ file tail $mom_event_handler_file_name ]
 regsub -nocase -- "$str" $mom_event_handler_file_name "" path

 set user_exe_file "${path}\\MP_angl_head.exe"
 set user_tmp_file "C:\\TEMP\\MP_angle_head.tmp"


    set x64 0

    set root_dir [MOM_ask_env_var UGII_ROOT_DIR] ;
    set user_is64 ${root_dir}ugtcl.dll
    if { [file exists $user_is64] } {
    	set sz [ file size $user_is64 ]
    	set sz [ expr double($sz) ]
     	# 616960  for 64bit
    	# 462848  for 32
    	if {$sz>600000.} { set x64 1 ; } else { set x64 0 ; }
    }

    set user_dll "_x32"
    if {$x64} { set user_dll "_x64" }

 set user_dll_file "${path}\\pivot_offsets${user_dll}.dll"
 global mom_load_dir_dlg
 set mom_load_dir_dlg "${path}\\pivot_offsets.dlg"
 if {[file exists $user_dll_file]} {

   global mom_param_l
   global mom_param_p
   set mom_param_l 0
   set mom_param_p 0

   catch { MOM_run_user_function "${user_dll_file}"  ufusr } errMes ;

   set angle_head_L_param [ expr double($mom_param_l) ]
   set angle_head_P_param [ expr double($mom_param_p) ]

 } else {

   if {[file exists $user_exe_file]==0 } {
      set mom_warning_info "\n\n      - \n $user_exe_file \n\n"
      PB_CMD_Messages
      MOM_abort $mom_warning_info
   } else {
     set err "" ;
     catch { set mes [ exec  -- $user_exe_file ] } err ;
     MOM_log_message "PB_CMD_Call_master_process -> $err \n"
   }

   if { [file exists $user_tmp_file]==0 } {
      set mom_warning_info "\n\n    = \n $user_tmp_file \n\n"
      PB_CMD_Messages
      #MOM_abort $mom_warning_info

      MOM_output_to_listing_device  "  :"
      MOM_output_to_listing_device  "  angle_head_L_param = $angle_head_L_param "
      MOM_output_to_listing_device  "  angle_head_P_param = $angle_head_P_param \n"
   } else {
       #====================

        set read_file [open $user_tmp_file "r" ]

        gets $read_file str
        set angle_head_L_param [ expr double($str) ]
        gets $read_file str
        set angle_head_P_param [ expr double($str) ]

        close $read_file

       #====================
   }

 }

##
 set mom_kin_4th_axis_center_offset(0) [expr -$angle_head_P_param]
 set mom_kin_4th_axis_center_offset(2) [expr -$angle_head_L_param - 300.043]

 set mom_kin_pivot_dist_vec(0)         [expr $angle_head_L_param + 300.043]
 set mom_kin_pivot_dist_vec(2)         $angle_head_P_param
 MOM_reload_kinematics

#MOM_output_to_listing_device  "testing ------------------ $mom_kin_4th_axis_center_offset(0)"
#MOM_output_to_listing_device  "testing ------------------ $mom_kin_4th_axis_center_offset(2)"
#MOM_output_to_listing_device  "testing ------------------ $mom_kin_pivot_dist_vec(0)"
#MOM_output_to_listing_device  "testing ------------------ $mom_kin_pivot_dist_vec(2)"
}



#=============================================================
proc PB_CMD_start_of_program { } {
#=============================================================
global mom_operation_name mom_group_name
global mom_logname mom_ug_version mom_date mom_part_name mom_machine_name
global mom_warning_info
global mom_definition_file_name mom_event_handler_file_name

 ;#     pivot_offsets
 if [llength [info commands PB_CMD_Call_master_process ] ] {
      PB_CMD_Call_master_process
 }

set str "\n    V-STAR  Sinumerik 840D ( )\n"
MOM_output_to_listing_device $str  ;

  set strname "" ;
  #if [llength [info commands PB_part_name] ] { set strname [ PB_part_name ] ; }

  set strmaterial "" ;
  #if [llength [info commands PB_part_material] ] {  set strmaterial [ PB_part_material ] ; }

  global prog_name
  set prog_name ""
  if {[info exists mom_operation_name]} { set prog_name $mom_operation_name }
  if {[info exists mom_group_name]} { set prog_name $mom_group_name }

#MOM_output_literal ";Part: $strname "
#MOM_output_literal ";Material: $strmaterial"
#MOM_output_literal ";Program: $prog_name"
#MOM_output_literal ";$mom_logname, Date:$mom_date "
#MOM_output_literal ";MACHINE: $mom_machine_name "

##
global mom_clamp_status
set mom_clamp_status "OFF"
MOM_clamp
MOM_output_literal "G90"
##
#   MOM_output_literal "SOFT"
#   MOM_output_literal "FFWON"
#   MOM_output_literal "G642"
#   MOM_output_literal "COMPCURV"
#   MOM_output_literal "UPATH"
##
MOM_output_literal "SPEC_UGV"
MOM_output_literal "COMPOF"
MOM_output_literal "TRAFOOF"
MOM_output_literal "G54"
##
##    correcteur
##
##     1 = CUT2D
##     2 = CUT2DF
##     3 = CUT3DC
##
MOM_output_literal "CUT2D"
##
MOM_output_literal "TIME_ON"
##
}


#=============================================================
proc PB_CMD_end_of_program { } {
#=============================================================
global mom_sys_control_out mom_sys_control_in
global mom_spindle_speed
global mom_clamp_status

set mom_clamp_status "OFF"
MOM_clamp ; # CLAMP  / ALL , OFF
MOM_coolant_off ; # COOLNT / OFF
MOM_spindle_off ;# SPINDL / OFF
;#MOM_output_literal "TRAFOOF" ; # RTCP / OFF
##PRBCUT "ENDPROG"
;#MOM_output_literal "TOOL_BREAK_CHECK"
MOM_output_literal "$mom_sys_control_out T22 $mom_sys_control_in"
MOM_output_literal "$mom_sys_control_out TOOL_CHANGE $mom_sys_control_in"
MOM_set_seq_off
MOM_output_literal "TIME_OFF"
##

  global mom_machine_time mom_kin_tool_change_time
  set mom_kin_spindle_time   0.0
  if  {$mom_spindle_speed>=12000.0 && $mom_spindle_speed<18000.0} {  set mom_kin_spindle_time   2.0 }
  if  {$mom_spindle_speed>=18000.0} {  set mom_kin_spindle_time   4.0 }

  set mom_machine_time [ expr $mom_machine_time + $mom_kin_tool_change_time + $mom_kin_spindle_time ]

  set str0 "[ format "%.1f" $mom_machine_time ]'"
  set str1 "    =$str0"
  set str2 ""
  if [llength [info commands outTime ]] { set str2 [ outTime $mom_machine_time ]  }
  #MOM_output_to_listing_device "$str1  $str2"  ;
  MOM_output_literal "$mom_sys_control_out Time=$str0 $str2 $mom_sys_control_in"
##
  global distance
  if {[info exists distance]} {
    set distance "[ format "%.3f" $distance ]"
    MOM_output_literal "$mom_sys_control_out Dist=${distance}mm $mom_sys_control_in"
  }

  global angle_head_L_param
  if {[info exists angle_head_L_param]} {
       set angle_head_L_param "[ format "%.3f" $angle_head_L_param ]"
       MOM_output_literal "$mom_sys_control_out L_param ygl golovki=$angle_head_L_param $mom_sys_control_in"
  }

##MOM_output_literal "FRONT_ROOF"
##MOM_output_literal "\$P_UIFR[1,C,TR]=0"
##MOM_output_literal "\$P_UIFR[1,Z,RT]=0"
##
MOM_set_seq_on
}


#=============================================================
proc PB_CMD_tool_change { } {
#=============================================================
  MOM_force Once G_motion X Y Z D

  global mom_clamp_status
  set mom_clamp_status "OFF"
  MOM_clamp ; # CLAMP  / ALL , OFF
  MOM_do_template auto_tool_change
#  MOM_coolant_off ;# COOLNT / OFF
#  MOM_spindle_off ;# SPINDL / OFF
  MOM_output_literal "TRAFOOF" ; # RTCP / OFF

  global cutter_type
;#  PRBCUT "CHECK"

  PB_CMD_tool_datas

  global mom_tool_number
#  set mom_tool_number 1

  MOM_force Once T
  MOM_do_template tool_change
  PB_CMD_cutcom_register
  MOM_output_literal "TOOL_CHANGE"
##
## BLUM
##
;#  MOM_output_literal "D3"
##
;#  set cutter_type [ SET_Tool_type ]
;#  if { $cutter_type == "MILL" } {
;#    set cutter_type "MILL"
;#    PRBCUT "MILL"
;#    global mom_tool_number mom_tool_diameter
;#    set d [ expr $mom_tool_diameter/2.0 ]
;#    set d [ format "%.3f" $d ]
;#    if [llength [info commands int_value] ] { set d [ int_value $d ] ; }
;#    MOM_output_literal "\$TC_DP6\[${mom_tool_number},2\]=${d}"
;#  } else {
;#    set cutter_type "DRILL"
;#    PRBCUT "DRILL"
;#  }
##
;#  MOM_set_seq_off
;#  MOM_output_literal "TRANS_COR"
;#  MOM_set_seq_on
##
  MOM_output_literal "D1"
  MOM_output_literal "G54"
##
  set rtcp 0
##  ETAT0.supres = 2
}



#=============================================================
proc PB_CMD_init_vars { } {
#=============================================================
global mom_warning_info
global mom_contact_status

set mom_contact_status "OFF"

global G10 G68
global axis5 axis5_flag axis5_flag2 axis5_flag_for_end eng_flag
global D_flag

# 
global mom_pos
set mom_pos(0) 0.0
set mom_pos(1) 1225.0
set mom_pos(2) 830.0

global from_flag
set from_flag 0

global i1 i2 i3
set i1 0 ;  set i2 0 ; set i3 0

set axis5 0
set D_flag 0

global clearp
global rtcp
global ofstno
global input
global output
global plan
global plan_cycle
global clamp
global clampb
global clampc
global cutter_type
global outil
global tprint
global ugv

set clearp -100000
set rtcp 0
set ofstno 54
set input 2
set output 2
set plan 0
set plan_cycle 0
set clamp 1
set clampb 0
set clampc 0
set cutter_type ""
set outil 0
set tprint ""
set ugv 1

global mom_source_directory
global mom_event_handler_file_name
global path
set path ""
set str [ file tail $mom_event_handler_file_name ]
regsub -nocase -- "$str" $mom_event_handler_file_name "" path

#    
global prev_spindle_speed    spindle_speed_flag
set prev_spindle_speed 0.0
set spindle_speed_flag 0

#   - 
global min_pos  max_pos
for { set ii 0 } {$ii<5} { incr ii } {
	set min_pos($ii) 99999.999
	set max_pos($ii) -99999.999
}

#       
    global pb_prev_machine_time
    set pb_prev_machine_time 0.0
    global pb_tool_use
    for {set i 0} {$i <= 100} {incr i} { set pb_tool_use($i) 0 }

#global mom_kin_coordinate_system_type
#set mom_kin_coordinate_system_type "MAIN"

global prev_theta_value  prev_c_value
set prev_theta_value   0
set prev_c_value   0

uplevel #0 {

 set mom_kin_read_ahead_next_motion 	      "TRUE"
#set mom_kin_nurbs_output_type                SIEMENS_POLY
 set mom_kin_nurbs_output_type                BSPLINE

 set mom_sys_helix_pitch_type	"none"
#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
#
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.

#
#  The following variable deines the output mode for helical records.
#
#  FULL_CIRCLE  -- This mode will output a helix record for each 360
#                  degrees of the helix.
#  QUADRANT  --    This mode will output a helix record for each 90
#                  degrees of the helix.
#  LINEAR  --      This mode will output the entire helix as linear gotos.
#  END_POINT --    This mode will assume the control can define an entire
#                  helix in a single block.

  set mom_kin_helical_arc_output_mode FULL_CIRCLE

 MOM_reload_kinematics

#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
  global mom_spindle_speed mom_warning_info mom_spindle_direction
     COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET

  global mom_programmed_feed_rate

  MOM_force Once G_motion X Y Z fifth_axis
  MOM_force Once S M_spindle
  set mom_spindle_direction "CCLW"
  MOM_do_template  spindle_rpm

  MOM_do_template  trans_x

   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
#      MOM_rapid_move
       MOM_do_template initial_move_rapid
#       MOM_output_literal "TRAORI"
#       MOM_output_literal "G54"
       MOM_force Once G_motion X Y Z fourth_axis
       MOM_do_template initial_move_rapid_z
   } else {
#      MOM_linear_move
       MOM_do_template initial_move_linear
#       MOM_output_literal "TRAORI"
#       MOM_output_literal "G54"
       MOM_force Once G_motion X Y Z fourth_axis
       MOM_do_template initial_move_linear_z
   }

}


} ;# uplevel

set G10 0

set G68 0

set axis5_flag ""
set axis5_flag2 0
set axis5_flag_for_end 0
set eng_flag 0
}

#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event mom_spindle_direction
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
    set mom_spindle_direction "CCLW"
   catch {MOM_$mom_motion_event}

}

#=============================================================
proc MOM_origin { } {
#=============================================================
#  PB_CMD_origin
}

#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
global mom_template_type mom_operation_name mom_operation_type
global mom_warning_info
global mom_motion_event
global mom_spindle_speed
global mom_kin_4th_axis_min_limit  mom_kin_4th_axis_max_limit
global mom_tool_axis mom_nxt_tool_axis mom_prev_tool_axis
global mom_out_angle_pos  mom_prev_out_angle_pos
global mom_pos mom_prev_pos mom_alt_pos mom_mcs_goto  mom_prev_mcs_goto  mom_prev_pos
global mom_pos_arc_center mom_arc_center
global mom_gohome_pos mom_from_pos  mom_from_status
global mom_motion_distance

global prev_c_value theta_value prev_theta_value c_value
global prev_spindle_speed  spindle_speed_flag
global from_flag

    set i [format "%-.5f" $mom_tool_axis(0)]
    set j [format "%-.5f" $mom_tool_axis(1)]
    set k [format "%-.5f" $mom_tool_axis(2)]

    if {$i=="0.0" && $j=="0.0" && ($k=="1.0" || $k=="-1.0") } {
      set mom_out_angle_pos(1) 0.0
      MOM_reload_variable -a mom_out_angle_pos
    }

    set ang_tmp [format "%-.3f" $mom_out_angle_pos(0) ]
    if {$ang_tmp=="0.0"} {
      set mom_out_angle_pos(0) 0.0
#      set mom_out_angle_pos(1) 0.0
      MOM_reload_variable -a mom_out_angle_pos
    }

 # global  mom_motion_event
 # if {$mom_motion_event=="initial_move"} {
 #  if {$mom_operation_type=="Point to Point" && $mom_out_angle_pos(0)<0.0} {
 #    set mom_pos(3) $mom_alt_pos(3)
 #    set mom_pos(4) $mom_alt_pos(4)
 #    set mom_out_angle_pos(0) $mom_pos(3)
 #    set mom_out_angle_pos(1) $mom_pos(4)
 #    MOM_reload_variable -a mom_out_angle_pos
 #  }
 # }

  if {[llength [info commands PB_CMD_calc_motion_distance] ]} {  PB_CMD_calc_motion_distance  }

  if {$mom_spindle_speed != 0} { set prev_spindle_speed  $mom_spindle_speed ; }
  if {$mom_spindle_speed == 0} {
        set mom_spindle_speed $prev_spindle_speed
        set st [ format "%.0f" $mom_spindle_speed ]
        set mom_warning_info "  '$mom_operation_name'      \n    = S$st"
        MOM_output_to_listing_device $mom_warning_info
        #if {$spindle_speed_flag==0} { PB_CMD_Messages }
        #MOM_abort "   !!!!!!"
        set spindle_speed_flag 1
  }

if {($mom_warning_info == "unable to determine valid rotary positions") || ($mom_out_angle_pos(0) < $mom_kin_4th_axis_min_limit) || ($mom_out_angle_pos(0) > $mom_kin_4th_axis_max_limit)} {
  set mom_warning_info "\t       $mom_operation_name \n"
  append mom_warning_info "\n         \n"
  append mom_warning_info "    "
  #MOM_output_to_listing_device $mom_warning_info
  if {[llength [info commands MOM_ui_message ] ]} {
    MOM_ui_message "ERROR" $mom_warning_info
   } else {
    PB_CMD_Messages
  }
  MOM_abort "\n\n\n      B!!!!!! \n\n\n"
}

 #if {[llength [info commands PB_CMD_calc_minmax] ]} {  PB_CMD_calc_minmax  }

global min_pos  max_pos
for { set ii 0 } { $ii<3 } { incr ii } {
   if  {$mom_pos($ii)<$min_pos($ii)} {  set min_pos($ii) $mom_pos($ii) ; } ; #min
   if  {$mom_pos($ii)>$max_pos($ii)} {  set max_pos($ii) $mom_pos($ii) ; } ; #max
}
if  {$mom_out_angle_pos(0)<$min_pos(3)} {  set min_pos(3) $mom_out_angle_pos(0) ; } ; #min
if  {$mom_out_angle_pos(0)>$max_pos(3)} {  set max_pos(3) $mom_out_angle_pos(0) ; } ; #max
if  {$mom_out_angle_pos(1)<$min_pos(4)} {  set min_pos(4) $mom_out_angle_pos(1) ; } ; #min
if  {$mom_out_angle_pos(1)>$max_pos(4)} {  set max_pos(4) $mom_out_angle_pos(1) ; } ; #max


 ;#   (duck-unduck)
 if [llength [info commands PB_CMD_pogo_process ] ] {
      PB_CMD_pogo_process
 }

     return ;
     #  Sinumerik -   G68,  Rotate TRANS ...
}



