########################## TCL Event Handlers ##########################
#
#  Created by chudoyakoveb  Tue May 11 00:10:48 2006  ()
#
########################################################################


  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]

#=============================================================
#The following command invokes the warning mode and the default settings.
#        .
#=============================================================

source "[MOM_ask_env_var UGII_CAM_POST_DIR]ugpost_base.tcl"

source "[MOM_ask_env_var UGII_CAM_POST_DIR]/vstar/vstar.tcl"

#=============================================================
#      .
#=============================================================
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl ;
 #source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ;
  MOM_set_debug_mode OFF

  set mom_kin_read_ahead_next_motion         1 ; # TRUE

#==============================================================

# 
 global table_pos ; # (, , ,{ON,OFF,DUCK,UNDUCK,""})

# 
 global dh dia delta
 set dh 19.05 ;
 set dia 90.0 ; # 80.264 - 90.0 ; # 
 
 set dop 48.26
  set dop_ygl 51.56

#  
 global xmin ymin
 set xmin 122.
 set ymin -1200.

#     
 global dx dy
 global nx ny n
 set dx 250. ;  set nx 6
 set dy 400. ;  set ny 7
 set n 7 ;# 
#   
  set  delta  1.0
#==============================================================	
proc PB_CMD_pogo_process { } {
#==============================================================
#   (duck-unduck)
global mom_template_type mom_operation_name
global mom_warning_info
global mom_event_number mom_event_error
global mom_motion_event
global mom_csys_matrix mom_msys_matrix  mom_msys_origin
global mom_coordinate_system_purpose
global mom_kin_coordinate_system_type
global mom_fixture_offset_value
global mom_motion_distance
global mom_tool_diameter

 if { [info exists mom_kin_coordinate_system_type ] == 0 }  { set mom_kin_coordinate_system_type "LOCAL" ; }

 #  
 global first_pogo
 if { [info exists first_pogo ] == 0 }  {
    set first_pogo 1
    PB_CMD_pogo_table
 }

# if {[EQ_is_gt $mom_motion_distance $mom_tool_diameter ]} {
# 	set  mom_warning_info "D=$mom_tool_diameter -  s=$mom_motion_distance "
# 	MOM_catch_warning
# 	MOM_output_to_listing_device $mom_warning_info
# }

 #   
 if [llength [info commands PB_CMD_pogo_methods1] ] {
     PB_CMD_pogo_methods1
 }

 #  
 if [llength [info commands PB_CMD_pogo_methods2] ] {
     PB_CMD_pogo_methods2
 }

 return
}



#==============================================================
proc PB_CMD_pogo_table { } {
#==============================================================
 global mom_warning_info
#   
 global table_pos
 global xmin ymin
 global dx dy
 global nx ny n

#  
 #   S=1..7
 for { set k 1 } { $k<=$n } { incr k } {
  #R=1..7
  for { set j 1 } { $j<=$ny } { incr j } {
   set y [ expr ( ($j*$dy-$dy) + $ymin ) ] ;
   #C=1..6
   for { set i 1; set ind [expr ($nx*($k-1)+1) ] } { $i<=$nx } { incr i ; incr ind } {
     set x [ expr ( ($ind*$dx-$dx) + $xmin ) ]
     set z 0.0 ; # 0.0 100.0
     set i1 0
     set j1  0
     set k1 1
     set table_pos($k,$j,$i) [ list $x $y $z $i1 $j1 $k1 "OFF" "TAB" ] ; # ON OFF TAB YGL
     #tk_messageBox -message "table_pos($k,$j,$i)=$table_pos($k,$j,$i,MODE)"
   }
  }
 }

 set fileName "C:/Temp/pogo_tables.txt"
 if {[file exists $fileName]==0} {
    set mom_warning_info "\n\n   =$fileName\n     ' '\n\n\n"
    MOM_catch_warning
    MOM_abort $mom_warning_info
 }

 set rf [open "$fileName" "r" ]
 gets $rf str
 while {![eof $rf]} {
   scan $str "%d %d %d %f %f %f %f %f %f" k j i x y z i1 j1 k1
   set z [format "%.3f" $z]
   set i1 [format "%.3f" $i1]
   set j1 [format "%.3f" $j1]
   set k1 [format "%.3f" $k1]
   if {![EQ_is_zero $z ]} { set table_pos($k,$j,$i) [ list $x $y $z $i1 $j1 $k1 "ON" "TAB" ] ; }
   gets $rf  str
 }
 close $rf ; # close the file




 set fileName "C:/Temp/pogo_ext.txt"
 if {[file exists $fileName]==0} {
    set mom_warning_info "\n\n   =$fileName\n     ' '\n\n\n"
    MOM_catch_warning
    MOM_abort $mom_warning_info
 }

 set rf [open "$fileName" "r" ]
 gets $rf str
 while {![eof $rf]} {
   scan $str "%d %d %d %f %f %f %f %f %f" k j i x y z i1 j1 k1
   set z [format "%.3f" $z]
   set i1 [format "%.3f" $i1]
   set j1 [format "%.3f" $j1]
   set k1 [format "%.3f" $k1]
   if {![EQ_is_zero $z ]} { set table_pos($k,$j,$i) [ list $x $y $z $i1 $j1 $k1 "ON" "YGL" ] ; }
   gets $rf  str
 }
 close $rf ; # close the file

 MOM_output_to_listing_device "==============  ================="
 set num 0
 #   S=1..7
 for { set k 1 } { $k<=$n } { incr k } {
  #R=1..7
  for { set j 1 } { $j<=$ny } { incr j } {
   #C=1..6 ---- set ind [expr ($nx*($k-1)+1) ] $ind<=[expr ($k*$nx)]
   for { set i 1 } { $i<=$nx } { incr i } {
     if {[ lindex $table_pos($k,$j,$i) 6 ]!="OFF"} { incr num ; MOM_output_to_listing_device "$num) $k $j $i  $table_pos($k,$j,$i)" }
   }
  }
 }
 MOM_output_to_listing_device "============================================"
 
 return ;
}


########################################################################
#
# Rodionova E.  - " ,   ,    "
#
#==============================================================
proc PB_CMD_pogo_methods1 { } {
#==============================================================
  global mom_warning_info
  global mom_event_number  mom_event_time
  global mom_motion_event mom_motion_type  mom_current_motion

  global mom_kin_machine_resolution
  global mom_kin_max_fpm  mom_kin_rapid_feed_rate
  global mom_feed_rapid_value
  global feed
  global mom_motion_distance

# mom_msys_origin -     -  WCS 
# mom_msys_matrix - 
# mom_csys_matrix - 9-x 10-y 11-z (  MAIN  -  WCS )
  global mom_csys_matrix mom_msys_matrix  mom_msys_origin
  global mom_coordinate_system_purpose ; # mom_coordinate_system_purpose - 1|0 - (| ) - MAIN
  global mom_kin_coordinate_system_type ; # mom_kin_coordinate_system_type - MAIN LOCAL
  global mom_fixture_offset_value
#

  global mom_tool_name
  global mom_machine_tool_manufacturer
  global mom_tool_diameter
  global mom_tool_direction
  global mom_tool_z_offset
  global mom_tool_length_adjust_register
  global mom_tool_number
  global mom_tool_corner1_radius
  global mom_next_tool_name
  global mom_next_tool_number
  global mom_tool_flutes_number

  global mom_prev_pos  mom_pos  mom_motion_distance  mom_tool_axis
  global mom_pos_arc_center  mom_arc_angle

  global mom_nxt_event  mom_nxt_event_count  mom_nxt_motion_event
  global mom_nxt_feed_rate mom_nxt_feed_rate_mode mom_nxt_mcs_goto  mom_nxt_tool_axis
  global mom_nxt_pos_arc_center  mom_nxt_arc_direction  mom_nxt_arc_angle mom_nxt_arc_radius

#    
 global table_pos
 global xmin ymin
 global dx dy
 global nx ny n
 global dh dia delta
 global prev_pos cur_pos nxt_pos
 global num ; #   (-)

#   (  1-  -     () )
 global first_pogo_run1

global line12 num dop dop_ygl
#============================================================================
#    ()
#============================================================================

 if {[info exists mom_current_motion]} {
# 	MOM_output_literal "mom_current_motion $mom_current_motion"
   if {$mom_current_motion=="rapid_move"} { return ; }
   if {$mom_current_motion=="from_move"} { return ; }
   if {$mom_current_motion=="initial_move"} { return ; }
      if {$mom_current_motion=="first_move"} { return ; }
 }

 #     - -  
 for { set ii 0 } { $ii<3 } { incr ii } {
    set jj [ expr 9+$ii ]
    set tmp $mom_csys_matrix($jj) ;
     if {$jj==9 && $tmp<=1000} { set tmp [ expr (10494.0- $tmp)]}
 #     if {$jj==11 }  set tmp [ expr (+141.02-67.31)] 
    if {$jj==11 } {
         set prev_pos($ii) [ expr ($tmp + $mom_prev_pos($ii)) ] ;
          set cur_pos($ii)  [ expr ($tmp + $mom_pos($ii)) ] ;
      
      } else {
#    set prev_pos($ii) [ expr ($tmp + $mom_prev_pos($ii)) ] ;
#    set cur_pos($ii)  [ expr ($tmp + $mom_pos($ii)) ] ;
          set prev_pos($ii) [ expr ($tmp - $mom_prev_pos($ii)) ] ;
          set cur_pos($ii)  [ expr ($tmp - $mom_pos($ii)) ] ;
        }
  #        MOM_output_literal "$prev_pos($ii)  $cur_pos($ii)"
    if { [info exists first_pogo_run1 ]==0 } { set prev_pos($ii) $cur_pos($ii) ; }
  #  set nxt_pos($ii)  [ expr ($tmp + $mom_pos($ii)) ] ;
        set nxt_pos($ii)  [ expr ($tmp - $mom_pos($ii)) ] ;
    set median_pos1($ii) [ expr ($cur_pos($ii) + $prev_pos($ii))/2.0 ] ;
    set median_pos2($ii) [ expr ($nxt_pos($ii) + $cur_pos($ii))/2.0  ] ;
 #   MOM_output_literal " cur_pos(ii) $cur_pos($ii) "
 }

 set first_pogo_run1 1 ;

 if {[info exists mom_nxt_motion_event]} {
   #     - -  
   for { set ii 0 } { $ii<3 } { incr ii } {
      set jj [ expr 9+$ii ]
      set tmp $mom_csys_matrix($jj) ;
 #     set nxt_pos($ii) [ expr ($tmp + $mom_nxt_mcs_goto($ii)) ] ;
    set nxt_pos($ii) [ expr ($tmp - $mom_nxt_mcs_goto($ii)) ] ;
      set median_pos2($ii) [ expr ($nxt_pos($ii) + $cur_pos($ii))/2.0  ] ;
   }
 } ; # end [info exists mom_nxt_motion_event]

#=========================================================================================
# MOM_output_literal "=======prev_pos===$prev_pos(0),$prev_pos(1),$prev_pos(2)"
# MOM_output_literal "=======cur_pos====$cur_pos(0),$cur_pos(1),$cur_pos(2)"
# MOM_output_literal "=======nxt_pos====$nxt_pos(0),$nxt_pos(1),$nxt_pos(2)"
#=========================================================================================

#=========================================================================================
 if {![info exists mom_tool_diameter]} { set mom_tool_diameter 0.0 ; }
 set tool_dia $mom_tool_diameter
 
#1) 
 set a1 [ expr $cur_pos(1)- $prev_pos(1) ] ;# y(i)-y(i-1)
 set b1 [ expr $prev_pos(0)- $cur_pos(0) ] ;# x(i-1)-x(i)
 set c1 [ expr ( $cur_pos(0)*$prev_pos(1)-$prev_pos(0)*$cur_pos(1) ) ] ;# x(i)y(i-1)-x(i-1)y(i)
 set sq1 [ expr sqrt($a1*$a1 + $b1*$b1) ] ;# sqrt(a1*a1+b1*b1)
 set sq1 [ format "%.4f" $sq1 ] ;

 set a2 [ expr $nxt_pos(1)- $cur_pos(1) ] ;# y(i+1)-y(i)
 set b2 [ expr $cur_pos(0)- $nxt_pos(0) ] ;# x(i)-x(i+1)
 set c2 [ expr ( $nxt_pos(0)*$cur_pos(1)-$cur_pos(0)*$nxt_pos(1) ) ] ;# x(i+1)y(i)-x(i)y(i+1)
 set sq2 [ expr sqrt($a2*$a2 + $b2*$b2) ] ;# sqrt(a2*a2+b2*b2)
 set sq2 [ format "%.4f" $sq2 ] ;

 set R1 [ expr ( pow($cur_pos(0)-$prev_pos(0),2)+pow($cur_pos(1)-$prev_pos(1),2) ) ] ;
 set R1 [ expr (sqrt($R1)+$tool_dia)/2.0 ]
 set R2 [ expr ( pow($nxt_pos(0)-$cur_pos(0),2)+pow($nxt_pos(1)-$cur_pos(1),2) ) ] ;
 set R2 [ expr (sqrt($R2)+$tool_dia)/2.0 ]

if { [info exists num ] == 0 }  { set num 0 ; }
set header_pogo 0 ; #  -    

#2)   'DUCK-UNDUCK' 
 #   S=1..7
 for { set k 1 } { $k<=$n } { incr k } {
  #R=1..7
  for { set j 1 } { $j<=$ny } { incr j } {
   #C=1..6
   for { set i 1 } { $i<=$nx } { incr i } {

     set value1 $table_pos($k,$j,$i) ;
     set mode [ lindex $value1 6 ]
     set mode1 [ lindex $value1 7 ]

     if {$mode=="OFF"} { continue ; }
     if {$mode=="DUCK"} { continue ; }
 #   MOM_output_literal "mode  $mode "
     set x [ lindex $value1 0 ] ; set x [ expr double($x) ] ;
     set y [ lindex $value1 1 ] ; set y [ expr double($y) ] ;
     set z [ lindex $value1 2 ] ; set z [ expr double($z) ] ;
     
     set i1 [ lindex $value1 3 ] ; set i1 [ expr double($i1) ] ;  set i1 [ expr (-1*$i1) ]
     set j1 [ lindex $value1 4 ] ; set j1 [ expr double($j1) ] ;  set j1 [ expr (-1*$j1) ]
     set k1 [ lindex $value1 5 ] ; set k1 [ expr double($k1) ] ; set k1 [ expr (-1*$k1) ]
               set  x_a [ expr ($x+$dh*$i1) ]
               set  y_a [ expr ($y+$dh*$j1) ]  
         if {$mode1=="TAB"} {   
          set  z_a [ expr ($z+$dh*$k1)+$dop ]
      }      
         if {$mode1=="YGL"} {  
          set  z_a [ expr ($z+$dh*$k1+$dop+$dop_ygl) ]
        }
     if {[EQ_is_zero $z]} { continue ; }
 #  MOM_output_literal "x  $x  y  $y z $z i1 $i1 j1 $j1 k1 $k1"
     #   
     set dl1 [ expr ( pow($median_pos1(0)-$x,2)+pow($median_pos1(1)-$y,2) ) ] ;
     set dl1 [ expr sqrt($dl1) ]
     set dl2 [ expr ( pow($median_pos2(0)-$x,2)+pow($median_pos2(1)-$y,2) ) ] ;
     set dl2 [ expr sqrt($dl2) ]
#    2


#     
#   
    set delta_pos_x_1(0) [ expr ($cur_pos(0) - $prev_pos(0)) ] ;
    set delta_pos_y_1(1) [ expr ($cur_pos(1) - $prev_pos(1)) ] ;
    set delta_pos_z_1(2) [ expr ($cur_pos(2) - $prev_pos(2)) ] ;
# MOM_output_literal " $delta_pos_x_1(0) $delta_pos_y_1(1) $delta_pos_z_1(2)"
       if {![ EQ_is_le abs($delta_pos_x_1(0)) abs($delta_pos_y_1(1)) ]} { 
       	set number [ expr abs($delta_pos_y_1(1))/$delta ] ; 
       	set number [ expr int($number)]
 #      	set delta_y $delta
       	  if {[ EQ_is_zero $number ]} { set number 1 ; }
       	 set delta_y [ expr $delta_pos_y_1(1)/$number ] ;  
       	set delta_x [ expr $delta_pos_x_1(0)/$number ] ; 
       	      	set delta_z [ expr $delta_pos_z_1(2)/$number ] ; 
       } else {
        	set number [ expr abs($delta_pos_x_1(0))/$delta ] ; 
         	set number [ expr int($number)]
  #       	set delta_x $delta
             	  if {[ EQ_is_zero $number ]} { set number 1 ; }
             	    	set delta_x [ expr $delta_pos_x_1(0)/$number ] ; 
         	set delta_y [ expr $delta_pos_y_1(1)/$number ] ;
         	    	      	set delta_z [ expr $delta_pos_z_1(2)/$number ] ; 
    }
  #    MOM_output_literal " $delta_x $delta_y $delta_z"
          set pr_pos(0) $prev_pos(0)
          set pr_pos(1) $prev_pos(1)
          set pr_pos(2) $prev_pos(2)
 #           MOM_output_literal " 1   $pr_pos(0) $pr_pos(1) $pr_pos(2) "
     for { set ik 0 } { $ik<$number } { incr ik } { 
          set pr_pos(0) [ expr ($pr_pos(0) + $delta_x) ] ;
          set pr_pos(1) [ expr ($pr_pos(1) + $delta_y) ] ;
          set pr_pos(2) [ expr ($pr_pos(2) + $delta_z) ] ;
  #         MOM_output_literal " $pr_pos(0) $pr_pos(1) $pr_pos(2) "
 #    set rast [ expr ( pow($pr_pos(0)-$x,2)+pow($pr_pos(1)-$y,2) ) ] ;
         set bv1  [ expr ($pr_pos(0)-$x_a)]
         set bv2  [ expr ($pr_pos(1)-$y_a)]
         set bv3  [ expr ($pr_pos(2)-$z_a)]
 #          MOM_output_literal "bv1 $bv1  $bv2  $bv3 "
     set rast [ expr ( pow($pr_pos(0)-$x_a,2)+pow($pr_pos(1)-$y_a,2)+pow($pr_pos(2)-$z_a,2) ) ] ;
       set rast [ expr sqrt($rast) ]
 #       MOM_output_literal " $pr_pos(0) $x_a $pr_pos(1) $y_a $pr_pos(2) $z_a"
 
  # if { $rast < 70 }  { MOM_output_literal "rast  $rast $k$j$i"
 #   MOM_output_literal " $pr_pos(0) $x_a $pr_pos(1) $y_a $pr_pos(2) $z_a"
  #  } 
     set rast [ expr ( $rast-$tool_dia/2.0-$dia/2.0 ) ]
 #   MOM_output_literal "rast1111111111  $rast "
       if {$mode!="DUCK"} {
   
 
              if {([EQ_is_le $rast 0.0])} {


       	      #  
       	      if {$header_pogo==0} {
 	#        MOM_output_literal "G4 P3"
 	#        MOM_output_literal "POPEN"
 	#        MOM_output_literal "M70"
 	#        MOM_output_literal "DPRNT \[BEGPOGOS\]"
     	        set header_pogo 1
       	      }

     	      incr num
     	      MOM_output_to_listing_device "========$num) ($k,$j,$i) - rast   $rast"
     	      
                   set line12($num) "====== $num) ($k,$j,$i)=============="
 
       	      set table_pos($k,$j,$i) [ list $x $y $z $i1 $j1 $k1 "DUCK" ]
       	          set value1 $table_pos($k,$j,$i) ;
                  set mode [ lindex $value1 6 ]
    #   	      MOM_output_literal "DPRNT \[DUCK S[format "%02d" $k] R[format "%02d" $j] C[format "%02d" $i]\]"   
}
        } ; # mode!="DUCK"

      
}
   } ;#i
  } ;#j
 } ;#k

 #   
 if {$header_pogo!=0} {
# 	MOM_output_literal "DPRNT \[ENDPOGOS\]"
# 	MOM_output_literal "M70"
# 	MOM_output_literal "PCLOS"
 }

 return ;
}






#=============================================================
proc PB_CMD_start_of_program { } {
#=============================================================
global mom_operation_name mom_group_name
global mom_logname mom_ug_version mom_date mom_part_name mom_machine_name
global mom_warning_info
global mom_definition_file_name mom_event_handler_file_name

set str "\n    V-STAR  Sinumerik 840D \n"
MOM_output_to_listing_device $str  ;

  global prog_name
  set prog_name ""
  if {[info exists mom_operation_name]} { set prog_name $mom_operation_name }
  if {[info exists mom_group_name]} { set prog_name $mom_group_name }

##
global mom_clamp_status
set mom_clamp_status "OFF"
MOM_clamp
MOM_output_literal "G90"
##
#   MOM_output_literal "SOFT"
#   MOM_output_literal "FFWON"
#   MOM_output_literal "G642"
#   MOM_output_literal "COMPCURV"
#   MOM_output_literal "UPATH"
##
MOM_output_literal "SPEC_UGV"
MOM_output_literal "TRAFOOF"
MOM_output_literal "G54"
MOM_output_literal "MSG(\"  Z=-6.300= \")"
MOM_output_literal "STOPRE"
##
##    correcteur
##
##     1 = CUT2D
##     2 = CUT2DF
##     3 = CUT3DC
##
MOM_output_literal "CUT2D"
##
MOM_output_literal "TIME_ON"
##
}




#=============================================================
proc PB_CMD_end_of_program { } {
#=============================================================
global mom_spindle_speed
global mom_clamp_status

set mom_clamp_status "OFF"
MOM_clamp ; # CLAMP  / ALL , OFF
MOM_coolant_off ; # COOLNT / OFF
MOM_spindle_off ;# SPINDL / OFF
MOM_output_literal "TRAFOOF" ; # RTCP / OFF
PRBCUT "ENDPROG"
;#MOM_output_literal "TOOL_BREAK_CHECK"
MOM_output_literal "; T22"
MOM_output_literal "; TOOL_CHANGE"
MOM_set_seq_off
MOM_output_literal "TIME_OFF"
##

  global mom_machine_time mom_kin_tool_change_time
  set mom_kin_spindle_time   0.0
  if  {$mom_spindle_speed>=12000.0 && $mom_spindle_speed<18000.0} {  set mom_kin_spindle_time   2.0 }
  if  {$mom_spindle_speed>=18000.0} {  set mom_kin_spindle_time   4.0 }

  set mom_machine_time [ expr $mom_machine_time + $mom_kin_tool_change_time +$mom_kin_spindle_time ]

  set str0 "[ format "%.1f" $mom_machine_time ]'"
  set str1 "    =$str0"
  set str2 ""
  if [llength [info commands outTime ]] { set str2 [ outTime $mom_machine_time ]  }
  #MOM_output_to_listing_device "$str1  $str2"  ;
  MOM_output_literal "; Time=$str0 $str2 "
##
  global distance
  if {[info exists distance]} {
  	set distance "[ format "%.3f" $distance ]"
  	MOM_output_literal "; Dist=${distance}mm"
  }
  
  global line12 num
  if {$num!=0} { MOM_output_literal ";  POGO   : " ; }
  for { set k 1 } { $k<=$num } { incr k } {
     MOM_output_literal ";$line12($k)"
  }
##MOM_output_literal "FRONT_ROOF"
##MOM_output_literal "\$P_UIFR[1,C,TR]=0"
##MOM_output_literal "\$P_UIFR[1,Z,RT]=0"
##
MOM_set_seq_on
}


#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file "vstar_pogo_methods1.tcl"
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file "vstar_pogo_methods2.tcl"
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }

